@echo off


if "%1" == ""       goto CMD
if "%1" == "?"      goto USAGE
if "%1" == "help"   goto USAGE
if "%1" == "list"   goto LIST
if "%1" == "update" goto UPDATE
if "%1" == "man"    goto MAN
if "%1" == "edit"   goto EDIT
if "%1" == "editbat" goto EDITBAT
if "%1" == "cd"     goto CD
if "%1" == "cmd"    goto CMD

goto END


:LIST
echo.
dir %ProgramsDir%\%ProgramName%
dir %ShareDir%\%ProgramName%
dir %WorkingRoot%\%ProgramName%

dir %DocDir%\%DocName%
dir %ProgramsManDir%\%DocName%
echo.

goto END

:UPDATE
echo.
echo Execute [%CopyCmd1%]
%CopyCmd1%

echo Execute [%CopyCmd2%]
%CopyCmd2%

echo Execute [%CopyCmd3%]
%CopyCmd3%
echo.

goto END

:MAN
echo Execute [start %DocDir%\%DocName%]
start %DocDir%\%DocName%
goto END

:EDIT
echo Execute [start %EDITOR% %ShareDir%\%ProgramName%]
start %EDITOR% %ShareDir%\%ProgramName%
goto END

:EDITBAT
echo Execute [start %EDITOR% %ProgramsRoot%\bin\update-python-programs.bat]
start %EDITOR% %ProgramsRoot%\bin\update-python-programs.bat
goto END

:CMD
cmd.exe /K cd /D %ShareDir%\
goto END

:CD
cd /D %ShareDir%\
goto END

:USAGE
echo.
echo Usage:
echo "update.bat [|?|list|update|man|edit|cd|cmd|editbat]"
echo     No argument, cmd: launch cmd.exe
echo     ?, help: show this usage
echo     list   : list related .py and .pptx files
echo     update : Update .py and .pptx files
echo                [%CopyCmd1%]
echo                [%CopyCmd2%]
echo                [%CopyCmd3%]
echo     cd     : change working directory to %ShareDir%\
echo     man    : show %DocDir%\%DocName%
echo     edit   : edit %ShareDir%\%ProgramName%
echo     editbat: edit %ProgramsRoot%\bin\update-python-programs.bat

echo.
goto END


:END
