#!/usr/bin/perl

use lib '.';
use lib "d:/Programs/Perl/lib";

use strict;

use CSV;

my $fname = "CSV.dat";
my $csv = new CSV;
$csv->Read($fname);

my $pLabelArray = $csv->LabelArray();
my $nData = $csv->nData();
print "nData: $nData\n";

my $pDataArray  = $csv->DataArray();
for(my $il = 0 ; $il < @$pLabelArray ; $il++) {
	print "," if($il > 0);
	print "$pLabelArray->[$il]";
}
print "\n";

for(my $i = 0 ; $i < $nData ; $i++) {
	print "i=$i: ";
	for(my $il = 0 ; $il < @$pDataArray ; $il++) {
		my $pData = $pDataArray->[$il];
		my $v = $pData->[$i];
		print "," if($il > 0);
		print "$v";
	}
	print "\n";
}


exit;
 