package AtomTypeObject;
use Exporter;
use Common;
@ISA = qw(Exporter Common);

#JTu[`
@EXPORT = qw();

use strict;

sub new
{
	my ($module) = @_;
	my $this = {};
	bless $this;
	return $this;
}

sub DESTROY
{
	my $this = shift;
}

sub SetCharge
{
	my ($this, $Charge) = @_;

	return $this->{Charge} = $Charge;
}

sub Charge
{
	my ($this) = @_;
	
	return $this->{Charge};
}

sub SetOccupancy
{
	my ($this, $Occupancy) = @_;

	return $this->{Occupancy} = $Occupancy;
}

sub Occupancy
{
	my ($this) = @_;
	return $this->{Occupancy} if(defined $this->{Occupancy});
	return 1.0;
}

sub SetAtomName
{
	my ($this,$AtomName) = @_;
	$this->{Label} = $AtomName;
	my ($Charge, $Occ);
#	if($AtomName =~ /^(.*?)(\d+?)?([+-])$/) {
	if($AtomName =~ /^([^\d+-]*)([\d+-\.]*)(\[([\d+-\.]+)\])?$/) {
		$AtomName = $1;
		$Charge   = $2;
		$Occ      = $4;
#print "occ=$Occ\n";
		$this->{'AtomName'} = $AtomName;
		if(defined $Charge) {
			my $cg = $Charge;
			$cg =~ s/[\+\-]//g;
			my $sign = ($Charge =~ /\-/)? -1 : 1;
#			my ($cg, $sign) = ($2, $3);
#			$cg   = 1 if($2 eq '');
#print "AtomName [$AtomName] [$Charge][$cg][$sign]\n";
			$sign = '' if(!defined $sign);
			if($sign =~ /-/) {	
				$Charge = -$cg
			}
			else {
				$Charge = $cg;
			}
		}
		else {
			$Charge = 0;
		}
		$this->{Charge}    = $Charge;
		$this->{Occupancy} = $Occ;
#print "at: $AtomName $Charge\n";
	}
	else {
		$this->{AtomName} = $AtomName;
	}

	return $AtomName;
}

sub IonizationPotential
{
	my ($this) = @_;
	return $this->{'IonizationPotential'};
}

sub ElectronAffinity
{
	my ($this) = @_;
	return $this->{'ElectronAffinity'};
}

sub AtomicRadius
{
	my ($this) = @_;
	return $this->{'AtomicRadius'};
}

sub IonRadius
{
	my ($this) = @_;
	return $this->{'IonRadius'};
}

sub AtomicMass
{
	my ($this) = @_;
	return $this->{'AtomicMass'};
}

sub SetAtomicMass
{
	my ($this, $mass) = @_;
	return $this->{'AtomicMass'} = $mass;
}

sub Label
{
	my ($this) = @_;
	return $this->{'Label'};
}

sub AtomNameOnly
{
	my ($this, $DelPar) = @_;
	my $name = $this->{AtomName};
	$name =~ s/\[.*?\]/$1/g;
	$name =~ s/^([^\d+-]*)([\d+-\.]*)/$1/;
	$name =~ s/\{[^\{\}]*\}//g if($DelPar);
	return $name;
}

sub AtomName
{
	my ($this) = @_;
	return $this->{'AtomName'};
}

sub AtomicNumber
{
	my ($this) = @_;
	return $this->{'AtomicNumber'};
}

sub SetAtomicNumber
{
	my ($this, $an) = @_;
	return $this->{'AtomicNumber'} = $an;
}

1;