#===============================================
# TestApp
#===============================================
package TestApp;
use MyApplication2;
@ISA = qw(MyApplication2);

use lib '../lib';
use strict;
use Authorization2;
use SQLDB2;

#==========================================
# ZLeB֌Wϐ
#==========================================
#Í̕@ "plain", "crypt", "md5", "sha1"
my $CryptMethod                  = "sha1";
my $CryptPhrase                  = "aelxzcvlerktog";
my $CheckPrivilegedIPAddress     = 1;
my $DoNotAllowPriviledgedAccount = 0;

#҃AJEg@AJEg:pX[h:x(1:Highest => 4:Lowest, 5: User)
my @PriviledgedAccount     = (
	"Admin:everybody:1",
	);
#҃AJEg̃ANZXIPAhX: ":"̌͋錠x̍ōl
my @PriviledgedIPAddress = (
	":1",			# Localhost
	"127.0.0.1:1",		# T[o[g
	"192.168.1.160:1",	# Kamiya2
	"131.112.140.160:1",	# J1
	"131.112.130.57:1",	# S2 5 or 6F
	"131.112.130.56:1",	# S2 5 or 6F
	);

#==========================================
# SQL֌Wϐ
#==========================================
my ($DBName, $TableName) = ('schedule_db', "schedule_tbl");
my $CSVDBDir = "d:\\";
my @DBConfigArray = (
	['DBConfigName',    'DBMName', 'DBServer', 'DBUser',     'DBPassword', 'DBName',           'TableName'        ],
	['mysql-usrv615',   'mysql', 'usrv615',   'schedule_user', 'OnnSennGeisya', $DBName,             $TableName        ],
	['csv-localhost',   'CSV',   'localhost', '',              '',         "$CSVDBDir/$DBName", "${TableName}.csv"],
	['mysql-localhost', 'mysql', 'localhost', 'schedule_user', 'password', $DBName,             $TableName        ],
	);

#============================================================
#@RXgN^AfXgN^
#============================================================
sub new
{
	my ($module, @args) = @_;
	my $this = {};
	bless $this;
	my $ret = $this->SUPER::new(
		-Title              => "Test App", 
		-Language           => "Japanese",
		-OutputMode         => "HTML",
		-Debug              => 0,
		-OSCharCode         => "sjis",
		-PrintCharCode      => "sjis",
		-FileSystemCharCode => "sjis",
		-SQLCharCode        => "sjis",
		-WebCharCode        => "sjis",
		-WebCharSet         => "x-sjis",
		@args);
	return $ret;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#============================================================
# ʊ֐
#============================================================
sub OpenDB
{
	my ($App, $config, $ShowErrorMessage) = @_;
	return SQLDB2::OpenDBByDBConfigArray($App, $config, \@DBConfigArray, $ShowErrorMessage);
}

sub GetLogonLevel
{
	my ($App, $Account, $Password, $ShowMessage) = (@_);
	my $Auth = new Authorization2(
			-CryptMethod                  => $CryptMethod,
			-CryptPhrase                  => $CryptPhrase,
			-PriviledgedAccount           => \@PriviledgedAccount,
			-PriviledgedIPAddress         => \@PriviledgedIPAddress,
			-CheckPrivilegedIPAddress     => $CheckPrivilegedIPAddress,
			-DoNotAllowPriviledgedAccount => $DoNotAllowPriviledgedAccount,
			);
	return $Auth->GetLogonLevel(
			-Application => $App,
			-Account     => $Account,
			-Password    => $Password,
			-ShowMessage => $ShowMessage,
			);
}

1;
