@echo off

:#========================
:# 要修正
:#========================
:# .pyファイル名
set ProgramName=bt2-T.py
:# .pptxファイル名
set DocName=50-08-BoltzTraP-bt2-T.pptx

:#========================
:# 修正不要
:#========================
:# [Programs]ルート
set ProgramsRoot=d:\Programs
:# f:\python
set PythonRoot=f:\python
:# f:\python\working
set WorkingRoot=%PythonRoot%\working
:# [data-COE]ルート
set ShareRoot=%PythonRoot%\data-COE
set EDITOR=D:\App\Editor\WZEditor64\wzeditor.exe

:# [data-COE]の.pptxフォルダー
set DocDir=%ShareRoot%\docs
:# [Programs]の.pptxフォルダー
set ProgramsManDir=%ProgramsRoot%\Manual

:#========================
:# 要修正
:#========================
:# [Programs]の.pyフォルダー
set ProgramsDir=%ProgramsRoot%\python\vasp
:# [data-COE]の.pyフォルダー
set ShareDir=%ShareRoot%\BoltzTraP-bt2-T
set PythonDir=%PythonRoot%\BoltzTraP

:#========================
:# 以下、修正不要
:#========================
:# Programsの.pyファイルを更新コピー
set CopyCmd1=xcopy /D %ProgramsDir%\%ProgramName% %ShareDir%\%ProgramName%
:# f:\python\workingの.pyファイルを更新コピー
set CopyCmd2=xcopy /D %WorkingRoot%\%ProgramName%   %ShareDir%\%ProgramName%
:# [data-COE]の.pptxファイルを更新コピー
set CopyCmd3=xcopy /D %ProgramsManDir%\%DocName%  %DocDir%\%DocName%


call %ProgramsRoot%\bin\update-python-programs.bat %*
goto END


:END
