set Engine=pwscf
set Sample=ZnO

:call run %Sample% %Engine% init null

set index=1111
call :RUN %Sample% %Engine% Cabc+ %index% 5 $nStep-1 0.01 0.0

set index=1212
call :RUN %Sample% %Engine% Cabc+ %index% 3 $nStep-1 0.01 0.0

set index=1133
call :RUN %Sample% %Engine% Cabc+ %index% 3 $nStep-1 0.01 0.0

set index=1122
call :RUN %Sample% %Engine% Cabc+ %index% 3 $nStep-1 0.01 0.0

set index=3333
call :RUN %Sample% %Engine% Cabc+ %index% 5 $nStep-1 0.01 0.0

set index=1111
call :RUN %Sample% %Engine% CXYZ+ %index% 5 $nStep-1 0.01 0.0

set index=2222
call :RUN %Sample% %Engine% CXYZ+ %index% 5 $nStep-1 0.01 0.0

set index=1212
call :RUN %Sample% %Engine% CXYZ+ %index% 5 $nStep-1 0.01 0.0

set index=3333
call :RUN %Sample% %Engine% CXYZ+ %index% 5 $nStep-1 0.01 0.0

set index=1313
call :RUN %Sample% %Engine% CXYZ+ %index% 5 $nStep-1 0.01 0.0

set index=1122
call :RUN %Sample% %Engine% CXYZ+ %index% 3 $nStep-1 0.01 0.0

set index=1133
call :RUN %Sample% %Engine% CXYZ+ %index% 3 $nStep-1 0.01 0.0

set index=2233
call :RUN %Sample% %Engine% CXYZ+ %index% 3 $nStep-1 0.01 0.0


goto END

call :RUN %Sample% %Engine% Vconst 1 5 4 0.005 0.0

call :RUN %Sample% %Engine% Vconst+ 1 5 4 0.005 0.0

call :RUN %Sample% %Engine% Vconp 1 11 5 500 0.0

set index=1111
call :RUN %Sample% %Engine% Cabc %index% 3 $nStep-1 0.01 0.0

set index=1212
call :RUN %Sample% %Engine% Cabc %index% 3 $nStep-1 0.01 0.0

set index=1122
call :RUN %Sample% %Engine% Cabc %index% 3 $nStep-1 0.01 0.0

set index=1133
call :RUN %Sample% %Engine% Cabc %index% 3 $nStep-1 0.01 0.0

set index=3333
call :RUN %Sample% %Engine% Cabc %index% 3 $nStep-1 0.01 0.0


goto :END


:RUN
set Sample=%1
set Engine=%2
set Mode=%3
set Index=%4
set nStep=%5
set nOrder=%6
set fdiff=%7
set pressure0=%8

call run %1 %2 %3 %4 %5 %6 %7 %8

set d=%Mode%%index%
mkdir %d%
move *.out %d%
move *.txt %d%
move *.csv %d%

exit /b


:END
