import numpy
import matplotlib.pyplot
import numpy as np
import urllib
import datetime as dt
import matplotlib.dates as mdates
from pymatgen.io.vasp.outputs import Vasprun
from pymatgen.electronic_structure.plotter import BSDOSPlotter,\
     BSPlotter,BSPlotterProjected,DosPlotter
dos_vasprun=Vasprun("./vasprun.xml")
dos_data=dos_vasprun.complete_dos
bs_vasprun=Vasprun("./vasprun.xml",parse_projected_eigen=True)
bs_data=bs_vasprun.get_band_structure(kpoints_filename= "./KPOINTS", line_mode=True)
plt_8=BSPlotterProjected(bs=bs_data)
fig_8=plt_8.get_elt_projected_plots_color()#elt_ordered=['','',""],title=""
matplotlib.pyplot.savefig('band.png',img_format='png',dpi=1000)


