#!/bin/bash
# use -x option for debug

HostName=`hostname`
RootDir=`pwd`
TemplateDir=$RootDir/Template
script=$TemplateDir/CalDielectricConstant.pl
#engine=gulp
engine=vasp

SampleName=$1
if [ "$SampleName" = "" ]; then
	SampleName=ZnO
fi
Library=$2
if [ "$Library" = "" ]; then
	Library=IGZO-Morse.lib
fi

perl $script --Action=MakeInputs $SampleName.cif
perl $script --Action=run --Engine=$engine

