:@echo off

::==================================
:: Directory config
::==================================
set ProgramsDir=d:\Programs
if not exist "%ProgramsDir%" (
	set ProgramsDir=c:\Programs
)
set PerlDir=%ProgramsDir%\Perl
set tee=%ProgramsDir%\bin\ktee.exe -a

set CMD=%PerlDir%\VASP\VASP.pl

set CIFFile=%1
if not exist "%CIFFile%" (
	echo.
	echo Error: Can not read [%CIFFile%].
	echo Usage: perl %CMD% CIF_File_Path
	echo.
	goto END
)

perl %CMD% --Action=MakeINCAR --Functional=PAW_PBE54 ^
	--UseConventionalCell=0 ^
	--UseRecommendedPOTCAR=1 --Function=scf ^
	--HybridFunctional=$HybridFunctional ^
	--BurstPOTCAR=0 ^
	--SpinPolarized=1 %CIFFile% .


:END
