#!/bin/bash
# use -x option for debug

. $DataRoot/scripts/vasp_config.sh


#====================================================
# Initialization
#====================================================
ThisScript=$0
BaseDir=`pwd`
OriginalDir=$BaseDir
WorkDir= 
ARGDIR=$BaseDir

#====================================
# Band
#====================================
echo 
echo ======================================================================
echo Execute [perl $VASPDir/EffectiveMassFromBand.pl]
echo ======================================================================
perl $VASPDir/EffectiveMassFromBand.pl

echo ' '
echo '================================================================'
echo "  Make summary"
echo '================================================================'
#echo
#echo == Execute [$VASPScriptDir/Summarize2.pl ./ \> Summarize.txt]
#perl $VASPScriptDir/Summarize2.pl ./ > Summarize.txt
#echo
#echo == Execute [$VASPScriptDir/Summarize.pl  ./ \> Summarize-SpinPolarized.txt]
#perl $VASPScriptDir/Summarize.pl  ./ > Summarize-SpinPolarized.txt
echo
echo == Execute [$VASPScriptDir/MakeSummaryHTML.pl]
perl $VASPScriptDir/MakeSummaryHTML.pl

echo 
echo ======================================================================
echo $0 finished.
echo ======================================================================
echo 
