#!/bin/bash
# use -x option for debug

BaseDir=`pwd`

echo
echo ============================================
echo
#echo run [. $DataRoot/scripts/vasp_config.sh]
#. $DataRoot/scripts/vasp_config.sh
echo run [. $BaseDir/vasp_config.sh]
. $BaseDir/vasp_config.sh
. $BaseDir/vasp_params.sh

echo
#printenv | sort
printenv | sort | grep Tk
printenv | sort | grep VASP
printenv | sort | grep aK
echo
echo == Execute [$VASPScriptDir/MakeSummaryHTML.pl]
echo ============================================

#====================================================
# Initialization
#====================================================
ThisScript=$0
BaseDir=`pwd`
OriginalDir=$BaseDir
WorkDir= 
ARGDIR=$BaseDir

echo ' '
echo '================================================================'
echo "  Make summary"
echo '================================================================'
echo
echo == Execute [$VASPScriptDir/Summarize2.pl ./ \> Summarize.txt]
perl $VASPScriptDir/Summarize2.pl ./ > Summarize.txt
echo
echo == Execute [$VASPScriptDir/Summarize.pl  ./ \> Summarize-SpinPolarized.txt]
perl $VASPScriptDir/Summarize.pl  ./ > Summarize-SpinPolarized.txt
echo
echo == Execute [$VASPScriptDir/MakeSummaryHTML.pl]
perl $VASPScriptDir/MakeSummaryHTML.pl


echo 
echo ======================================================================
echo $0 finished.
echo ======================================================================
echo 
