#!/bin/bash
# use -x option for debug

. $DataRoot/scripts/vasp_config.sh


#====================================
# VCRelax postprocess
#====================================
echo 
echo ======================================================================
echo Execute [$MakeCIFCMD .]
echo ======================================================================
$MakeCIFCMD .

echo 
echo ======================================================================
echo Execute [$MakeSymmetrizedCIFCMD]
echo ======================================================================
$MakeSymmetrizedCIFCMD

echo 
echo ======================================================================
echo Execute [$MakeXSFCMD .]
echo ======================================================================
$MakeXSFCMD .
#phonopy --symmetry | tee Symmetry.txt

#if [ -f $BaderCMD -a -f "AECCAR0" -a -f "AECCAR2" ]; then
#	$CMD --Action=AddCharges AECCAR0 AECCAR2 CHGCAR_sum
#	$BaderCMD CHGCAR -ref CHGCAR_sum
#	$CMD --Action=SummarizeBader --kVolume=$UpdateRWIGsByRBader . ACF.dat AVF.dat BCF.dat Bader.out
#fi

#if [ "$UpdateRWIGsByRBader" != "" ]; then
#	$CMD --Action=UpdateRWIGsByRBader . Bader.out
#	cp INCAR INCAR.original
#fi

#if [ "$UpdateRWIGsByRBader" != "" ]; then
#	cp INCAR.RWS INCAR
#fi

echo ' '
echo '================================================================'
echo "  Make summary"
echo '================================================================'
#echo
#echo == Execute [$VASPScriptDir/Summarize2.pl ./ \> Summarize.txt]
#perl $VASPScriptDir/Summarize2.pl ./ > Summarize.txt
#echo
#echo == Execute [$VASPScriptDir/Summarize.pl  ./ \> Summarize-SpinPolarized.txt]
#perl $VASPScriptDir/Summarize.pl  ./ > Summarize-SpinPolarized.txt
echo
echo == Execute [$VASPScriptDir/MakeSummaryHTML.pl]
perl $VASPScriptDir/MakeSummaryHTML.pl

echo 
echo ======================================================================
echo $0 finished.
echo ======================================================================
echo 
