@echo off
set ProgramsDir=d:\Programs
set TkPerlDir=%ProgramsDir%\Perl

set RietanDir=%ProgramsDir%\XRD\RIETAN-FP\RIETAN_VENUS
set PerlRietanDir=%TkPerlDir%\RietanFP

set r=%2
set Grange=%3

echo .
echo Run [perl %PerlRietanDir%\Madel.pl --Action=MakeInput --IonRadius=%r% --Grange=%Grange% %1.cif]
perl %PerlRietanDir%\Madel.pl --Action=MakeInput --IonRadius=%r% --Grange=%Grange% %1.cif

echo .
echo Run [%RietanDir%\MADEL.exe %1.pme %1.madel]
%RietanDir%\MADEL.exe %1.pme %1.madel

echo .
echo Run [perl %PerlRietanDir%\Madel.pl --Action=AddSummaryCSV %1.madel Summary.csv]
perl %PerlRietanDir%\Madel.pl --Action=AddSummaryCSV %1.madel Summary.csv
