#ifndef __CONSTANTS_H_INCLUDED__
#define __CONSTANTS_H_INCLUDED__

#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include <float.h>
#include <iostream>
#include <cstdlib>
#include <complex>

//#include "Vector.h"
#include "Common.h"

using namespace std;   

//extern const int BUF_LEN;
//extern const int NMAX_TOKEN;

extern const char TAB;
extern const char LF;

class CConstants
{
public:
	const static double a0; // m Bohr radius
	const static double me; // kg
	const static double NA; // mo-1
	const static double R;  // cal/mol/K
	const static double e0; // F/cm
	const static double u0; // H/cm
	const static double c;  // cm/s
	const static double h;    // J*s
	const static double hbar; // J*s
	const static double e;  // C
	const static double toeV;
	const static double toJ;
	const static double kB; // J/K
	const static double pi;
	const static complex<double> i; // Imaginary unit
	const static double toDeg;
	const static double toRad;
};

#endif