import sys
import os


exclude_list = ['importlib']
replace_list = {'scikit-learn': 'sklearn', 'python-pptx': 'pptx'}

argv = sys.argv
nargv = len(argv)


print("")
cmd = f"pip3 install --upgrade pip"
print(f"Update pip by [{cmd}]")
try:
    os.system(cmd)
except:
    print(f"Error: Cannot execute [{cmd}]")


print("")
try:
    import importlib
    print("Ok: importlib is installed")
except:
    cmd = f"pip3 install importlib"
    print(f"importlib is not found. Install by [{cmd}]")
    os.system(cmd)

for arg in argv[1:]:
    if arg in exclude_list:
        continue

    module_name = replace_list.get(arg, arg)
    try:
        importlib.import_module(module_name)
        print(f"Ok: {module_name} is installed")
    except:
        cmd = f"pip3 install {module_name}"
        print(f"{module_name} is not found. Install by [{cmd}]")
        os.system(cmd)

#print("")
#input("Press ENTER to exiet>>")
print("")
