#===============================================
# TkDVXa
#===============================================
package TkDVXa;
use Crystal::DVXa;
use MyTk::TkCommon;
@ISA = qw(DVXa TkCommon);

#JTu[`
#@EXPORT = qw(DelSpace Reduce01 MakePath RegExpQuote);

use strict;

use Utils;
use Deps;

use MyTk::TkGPGL;

BEGIN {
}

sub new
{
	my ($module, $app, $canvas) = @_;
	my $this = {};
	bless $this;
	$this->SetApplication($app);
	$this->SetCanvas($canvas);
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

sub SetCanvas          { my($this,$can)=@_; return $this->{'Canvas'} = $can; }
sub Canvas             { return shift->{'Canvas'}; }
sub GetGraphFrameArray { return shift->{'GraphFrameArray'}; }

sub CreateGraphFrame
{
	my ($this, $canvas) = @_;
	$this->SetCanvas($canvas) if($canvas);
	$canvas = $this->Canvas() unless($canvas);

	my $App = $this->App();
	my $font = $App->{'GraphFrameFont'};
	my @font = split(/,/, $font) if($font);
	my $w = $canvas->width();
	my $h = $canvas->height();

# Canvas, GraphFramȅ

	my $FileType = $this->FileType();
	if($FileType =~ /Fitting/i) {
	}
}

sub AssignGraphData
{
	my ($this) = @_;

	$this->AdjustViewRange();
}

sub AdjustViewRange
{
	my ($this) = @_;

}

sub Draw
{
	my ($this, $canvas) = @_;
	$canvas = $this->Canvas() unless($canvas);

	my $GPGL = new TkGPGL($this->App(), $canvas);
	$GPGL->SetFileName($this->FileName());
	return $GPGL->Draw($canvas);
}

1;