
use lib 'd:/Programs/Perl/lib';
use Sci qw(Gamma FermiDiracIntegral FermiDiracIntegralByNumericalIntegration);

for(my $r = 0.2 ; $r < 5.0 ; $r += 0.2) {
	my $G  = Gamma($r);
#	my $G2 = c_gamma($r);
	my $xi = -2;
	my $F  = FermiDiracIntegral($xi, $r);
	my $F2 = FermiDiracIntegralByNumericalIntegration($xi, $r);
#	printf "r=%6.2f: G=%8.4f/%8.4f F=%8.4f\n", $r, $G, $G2, $F;
	printf "r=%6.2f: G=%8.6f F=%8.6f/%8.6f\n", $r, $G, $F, $F2;
}

for(my $x = -5.0 ; $x <= 10.0 ; $x += 0.5) {
	my $r1 = 2.5;
	my $r2 = $r1 - 1.0;
	my $F1 = FermiDiracIntegral($x, $r1);
	my $F2 = FermiDiracIntegral($x, $r2);
	printf "x=%6.2f: F($r1)=%8.4f F($r2)=%8.4f R=%8.4f\n", $x, $F1, $F2, $F1 / $F2;
}
