#===============================================
# TkIV
#===============================================
package TkIV;
# TkPlotModulěpNXƂ
use TkPlotModule;
@ISA = qw(TkPlotModule);

use lib 'd:/Programs/Perl/lib';
use lib 'd:/Programs/Perl/lib2.0';
use lib 'd:/Tsukamoto';
use lib '.';

use strict;
use Utils;
use MyTk::GraphFrameArray;
use GraphData;
use Device::Device;

my $Port       = "GPIB27";
my $ModuleName = "Keithley6517A";
#my $Port       = "Dummy";
#my $ModuleName = "Keithley6517A_Dummy";

#============================================================
#@RXgN^AfXgN^i񑩁j
#============================================================
sub new
{
	my ($module, $app, $canvas) = @_;
	my $this = {};
	bless $this;
	$this->SetApplication($app);

	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#============================================================
#@pNXŒ`ȂEBhE֌Wo[֐
#============================================================
# ȉAW̓ꍇ́Amw()̕W֐Ăяo
# undefԂƁAꂼ̃EWFbg쐬Ȃ

# EWFbgŜ̍쐬
# mw()->InitCreateWidgets()ĂяoA
# EBhE^CgύXĂ
sub CreateWidgets
{
	my ($this) = @_;
	my $mw = $this->mw();
	my $ret = $mw->InitCreateWidgets();
	my $Frame = $mw->MyFrame()->pack(-fill => 'x'); #$mw->{'DataClassFrame'};

# f[^ۑt@CI
	my $Frame0 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'FileLabel'} = $Frame0->MyLabel(
					-text => 'Save File:'
				)->pack(-side => 'left');
	$this->{'FileEntry'} = $Frame0->MyEntry(
			-width => 50,
			-takefocus => 1,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'FileEntry'}->focus();
	$this->{'FilePathButton'} = $Frame0->MyButton(
			-text => '&Choose',
			-takefocus => 1,
			-command => [ \&ChooseFile, $this, $this->{'FileEntry'} ],
		)->pack(-side => 'left');
	$this->{'FileEntry'}->SetText('a.txt');

# C^[o͂eLXg{bNX(Entry)
	my $Frame1 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'IntervalLabel'} = $Frame1->MyLabel(
					-text => 'Interval:'
				)->pack(-side => 'left', -fill => 'x');
	$this->{'IntervalEntry'}     = $Frame1->MyEntry(
					-width => 30,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'IntervalEntry'}->SetText("500");
	$this->{'IntervalUnitLabel'} = $Frame1->MyLabel(
					-text => 'ms'
				)->pack(-side => 'left');

# ς񐔂͂eLXg{bNX(Entry)
	my $Frame2 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'nAverageLabel'} = $Frame2->MyLabel(
					-text => '# of Average:',
				)->pack(-side => 'left', -fill => 'x');
	$this->{'nAverageEntry'} = $Frame2->MyEntry(
					-width => 5,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'nAverageEntry'}->SetText(10);

	$this->{'VRangeLabel1'} = $Frame2->MyLabel(
					-text => '  Voltage range:',
				)->pack(-side => 'left', -fill => 'x');
	$this->{'V0Entry'} = $Frame2->MyEntry(
					-width => 5,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'V0Entry'}->SetText(-3);
	$this->{'VRangeLabel2'} = $Frame2->MyLabel(
					-text => ' - ',
				)->pack(-side => 'left', -fill => 'x');
	$this->{'V1Entry'} = $Frame2->MyEntry(
					-width => 5,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'V1Entry'}->SetText(3);
	$this->{'VRangeLabel3'} = $Frame2->MyLabel(
					-text => ', Step:',
				)->pack(-side => 'left', -fill => 'x');
	$this->{'VStepEntry'} = $Frame2->MyEntry(
					-width => 5,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'VStepEntry'}->SetText(0.1);
	$this->{'VRangeLabel4'} = $Frame2->MyLabel(
					-text => ' V',
				)->pack(-side => 'left', -fill => 'x');

# Start(Stop){^Clear{^
	my $Frame3 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'StartButton'} = $Frame3->MyButton(
					-text => 'Start',
					-takefocus => 1,
					-command => [ \&StartButton, $this, "Start" ],
				)->pack(-side => 'left', -fill => 'x');
	$this->{'ClearButton'} = $Frame3->MyButton(
					-text => 'Clear',
					-takefocus => 1,
					-command => [ \&StartButton, $this, "Clear" ],
				)->pack(-side => 'left', -fill => 'x');

# CEBhẼ^Cgݒ
	$mw->SetTitle("I-V measurement / TkPlot");
	return $ret;
}

# t@CIyC쐬Ȃ
sub CreateSelectFilePane
{
	my ($this) = @_;
#	return $this->mw()->CreateSelectFilePane();
	return undef;
}

# t@CeXg{bNXAeLXg{bNX쐬Ȃ
sub CreateFileContentPane
{
	my ($this) = @_;
#	return $this->mw()->CreateFileContentPane();
	return undef;
}

# ̃Otg쐬
# FInitCreateGraphFrameArray  AvP[VNɈxĂ΂Ȃ
# @@CreateGraphFrame  Ot`惂W[ŁAf[^t@C̓ǂݍ݂̂тɌĂяo
sub InitCreateGraphFrameArray
{
	my ($this, $canvas) = @_;
# $canvasnȂꍇ̂߁A$this->Canvas()Ăяo
	$canvas = $this->Canvas($canvas);
# pɂɎgϐ擾
# TkApplicationIuWFNg
	my $App = $this->App();
# TkPlotModuleIuWFNgB̏ꍇ́ATkGPIBTestIuWFNggԂ
	my $pDataArray = $App->TkData();
# Init@C̐ݒ肩tHgݒ肷
	my $font = $App->{'GraphFrameFont'};
	my @font = split(/,/, $font) if($font);
# LoX̕`敝ƍ
	my $w = $canvas->width();
	my $h = $canvas->height();

# Otg̔zIuWFNgA{'GraphFrameArray'}Ɋi[
	my $GraphFrameArray = $this->{'GraphFrameArray'}
			= new GraphFrameArray($this->mw());
# Ô߁AOtg̔zIuWFNgɂLoXTCYݒ
	$GraphFrameArray->SetCanvasSize($w, $h);

# OtgA$GraphFrame0Ɏ擾
	$GraphFrameArray->AddGraphFrame();
	my $GraphFrame0  = $GraphFrameArray->GetGraphFrame(0);

# Init@C̐ݒ肩Otg̈ʒuݒ肷
	my $FramePosStr0 = $App->{"GraphFramePosition"};
	$GraphFrame0->SetPositionByStr($FramePosStr0);

# Otg̖ڐɂ镶ݒ肷
	$GraphFrame0->SetXCaption("X");
	$GraphFrame0->SetYCaption('Y');

# Otg̕\͈͂ݒ肷B
	$GraphFrame0->SetViewRange(0, 0, 1, 1);

# f[^̔z
	my @X;
	my @Y;
# f[^̔z$GraphFrame0Ɍт
# AddGraphDataɂ́Af[^z̃t@Xn
#@@0,'black'́A 0AF'black'̐`  `Ȃ
#@@"dot", 1, "red", 0, "red",́A"red"Fdot`悷
#@@"XAutoSkip"́Af[^ʂƂɁAʂ̉𑜓xɍ킹ĕ`f[^XLbv
#@@Ō"x","y"́AX,Yf[^ɂ閼OBقƂǈӖ͂Ȃ
	$GraphFrame0->AddGraphData(\@X, \@Y, 0, 'black',
			"circle", 3, "red", 0, "red", "XAutoSkip",
			"x", "y");

	return undef;
}

#=======================================================================
#  bindꂽ֐
#=======================================================================

#t@CI{^ƂɌĂ΂
sub ChooseFile
{
	my ($this, $widget) = @_;
	my $fmask = '*.*';
	my $defstr = '';
	my $message = 'Choose file';
	my $dir = '';
	my $filepath = Dialog::OpenFileDialog($this->mw(), 
				'save', $fmask, $defstr, $message, $dir);
	if($filepath) {
		if($widget) {
			$widget->SetText($filepath);
		}
	}
	return $filepath;
}

#Start, Clear{^ꂽƂɌĂ΂
#$actionɁAǂ̃{^ꂽ̏񂪓
sub StartButton {
	my ($this, $action) = @_;
	my $button = $this->{'StartButton'};
	my $text = $button->GetText();

	if($action =~ /start/i) {
# Start{^ꂽƂAStart{^̏Ԃ"Start""Stop"
# ȂĂ邩ɂďς
		if($text =~ /start/i) {
			print "Press for Start\n";
			$this->PressStart();
			$button->SetText("Start");
		}
		elsif($text =~ /stop/i) {
			print "Press for Stop\n";
			$this->PressStop();
		}
	}
	elsif($action =~ /clear/i) {
		print "Press for Clear\n";
		$this->PressClear();
	}
}

#=======================================================================
#  Ăяo֐
#=======================================================================

sub Measure
{
	my ($this) = @_;
#"Stop"{^ƁA'DoStop'1ɂȂB̂ƂAɋA
	return if($this->{'DoStop'});

	my $GraphFrameArray = $this->{'GraphFrameArray'};
	my $GraphFrame = $GraphFrameArray->GetGraphFrame(0);
	my $data = $GraphFrame->GetPlotData(0);

#JE^[ϐ擾
	my $c = $this->{'Count'};

#Start: GPIBV~[V[`FGPIBŃf[^$x,$yɎ󂯎
	my ($x, $y) = $this->MeasureByCount($c);
#End: GPIBV~[V[`

	$data->AddData($x, $y);

#f[^R\[ɕ\
	$x = Utils::Round($x, 4); #L4ɐ؂l߂
	$y = Utils::Round($y, 4); #L4ɐ؂l߂
	print "$c: ($x,$y)\n";
#f[^t@Cɏ
	if($this->{'OutFileClass'}) {
		$this->{'OutFileClass'}->Write("$c\t$x\t$y\n");
	}

#f[^$GraphFrame̍őEŏlXV
	$data->CalMinMax();
	$GraphFrame->CalMinMax();
#f[^͈̔͂ɂ킹$GraphFrame̕`͈͂ςꍇ
	$GraphFrame->AdjustViewRange(0.05, 0.05, 0.05, 0.05);
#\͈͂Œ肷ꍇ
#	$GraphFrame->SetViewRange(0, 0, 1, 1);

#ĕ`
	$this->Draw();
	$this->mw()->update;

#JE^[ϐXV
	$this->{'Count'} += 1;
}




#ۂ̑胋[`
sub MeasureByCount
{
	my ($this, $count) = @_;

	my $x = $this->{VStart} + $this->{VStep} * $count;
	$this->{K6517A}->SetSourceVoltage($x);
	my $y = $this->{K6517A}->MeasureAveraged($this->{nAverage});
	return ($x, $y);
}

sub PressStart
{
	my ($this) = @_;
	my $button = $this->{'StartButton'};

#t@C擾Ałɑ݂邩ǂ`FbN
	my $FileName = $this->{'FileEntry'}->GetText();
#t@CIĂȂƂ́AbZ[Woď𒆎~
	if(!$FileName) {
		$this->mw()->messageBox(
			-icon => "info",  # "info" "warning" "question"
			-type => "Ok",    # "YesNo" "YesNoCancel" "OkCancel" "RetryCancel"
			-title => 'Error on FileName',
			-message => "FileName is not selected.\nChoose it.");
		return undef;
	}
#t@C݂Ƃ́A㏑̊mF
	if(-e $FileName) {
		my $ret = $this->mw()->messageBox(
			-icon => "question", # "info" "warning" "question"
			-type => "YesNo", # "YesNo" "YesNoCancel" "OkCancel" "RetryCancel"
			-title => 'Confirm for overwrite',
			-message => "$FileName exists.\nOverwrite?");
		return unless($ret eq 'Yes');
	}

	$this->{nAverage} = $this->{nAverageEntry}->GetText();
	my $VStart = $this->{VStart} = $this->{V0Entry}->GetText();
	my $VEnd   = $this->{VEnd}   = $this->{V1Entry}->GetText();
	my $VStep  = $this->{VStep}  = $this->{VStepEntry}->GetText();
	my $nVStep = $this->{nVStep} = int( ($VEnd - $VStart) / $VStep + 1.0001 );
	$this->{K6517A} = new Device(
		-Port               => $Port,
		-ModuleName         => $ModuleName);

	my $VMax = abs($VStart);
	$VMax = abs($VEnd) if($VMax < abs($VEnd));

	$this->{K6517A}->Initialize();
	$this->{K6517A}->SetDCCurrentMode("off");
	$this->{K6517A}->SetVSourceLimit($VMax);
	$this->{K6517A}->SetAutoRangeForCurrent("on");

	$this->{K6517A}->SetSourceVoltage($VStart);
	$this->{K6517A}->SetVSourceOutput("on");

	$button->SetText("Stop");
	$this->{'DoStop'} = 0;
	$this->{'Count'}  = 0;

#t@C݂悤ɃI[v
	$this->{'OutFileClass'} = new JFile($FileName, "w");
	if(!$this->{'OutFileClass'}) {
		$this->mw()->messageBox(
			-icon => "info",  # "info" "warning" "question"
			-type => "Ok",    # "YesNo" "YesNoCancel" "OkCancel" "RetryCancel"
			-title => 'Error',
			-message => "Can not write to $FileName.");
		return undef;
	}

# f[^̓ǂݍ݂[vōsƁA{^̍XVȂǂłȂ̂ŁA
# ^C}[(mw()->after())g$itime msMeasure()֐Ăяo
#	my $itime = $this->{'IntervalEntry'}->GetText();

	for(my $i = 0 ; $i < $nVStep ; $i++) {
# Stop{^ƁA{'DoStop'}1ɂȂ
		last if($this->{DosStop});
		$this->Measure();
	}

	if($this->{'OutFileClass'}) {
		$this->{'OutFileClass'}->Close();
		delete $this->{'OutFileClass'};
	}
}

sub PressClear
{
	my ($this) = @_;

	my $GraphFrameArray = $this->{'GraphFrameArray'};
	my $GraphFrame = $GraphFrameArray->GetGraphFrame(0);
	my $data = $GraphFrame->GetPlotData(0);
	$data->ClearAll();
	$GraphFrame->CalMinMax();
	$this->Draw();
}

# {'DoStop'}1āA胋[vI
sub PressStop
{
	my ($this) = @_;
	$this->{'DoStop'} = 1;
}

1;