#!/bin/bash

# Determine programs
TEE=$HOME/bin/ktee
MXDFileConv=$HOME/bin/MXDFileConv.exe
VASPDir=$TkPerlDir/VASP
VASPPL=$VASPDir/VASP.pl
export "CMD=/usr/bin/perl $VASPPL"

CIFFile=SnO.cif
UseConventionalCell=No
if [ -n "$1" ]; then
	CIFFile=$1
fi

# Basic parameters
DefaultFunction=scf
#Functional=PAW
Functional=PAW_PBE
SpinPolarized=No

$CMD --Action=MakeINCAR --UseConventionalCell=$UseConventionalCell --Function=$DefaultFunction --Functional=$Functional --SpinPolarized=$SpinPolarized $CIFFile ./
