@echo off

set TemplateDir=.\Template
set script=%TemplateDir%\CalDielectricConstant.pl
set engine=gulp
::set engine=vasp

set SampleName=%1
if "%SampleName%" == "" (
	set SampleName=ZnO
)
set Library=%1
if "%Library%" == "" (
	set Library=IGZO-Morse.lib
)

::Remove extension
set SampleName=%SampleName:.cif=%
set SampleName=%SampleName:.glp=%
set SampleName=%SampleName:.gin=%
set SampleName=%SampleName:.out=%
set SampleName=%SampleName:.axsf=%
set SampleName=%SampleName:.arc=%
set SampleName=%SampleName:.trg=%
set SampleName=%SampleName:.pre=%

@echo on

perl %script% --Action=MakeInputs %SampleName%.cif
perl %script% --Action=run --Engine=%engine%

:END
