:set mode=plot_all
:set mode=plot_one
:set mode=plot_one2
set mode=fit

set plugin_dir=filter
set infile=mixture.txt
:set infile=mixture.xlsx
:set infile=mixture.csv
set cif_files=data/*.cif

set source=CuKa1*1+CuKa2*0.5

set Q2min=20
set Q2max=100
set Q2step=0.02

set fwhm=0.1
set Gfraction=1.0
set fwhm_smear=0.1
set Gfraction_smear=0.0
set BGorder=2
set alpha=0.0e-4
:set yscale=log
set yscale=linear

python xrd_fit.py %mode% %plugin_dir% %infile% %cif_files% %source% %Q2min% %Q2max% %Q2step% ^
		%fwhm% %Gfraction% %fwhm_smear% %Gfraction_smear% ^
		%yscale% %BGorder% %alpha%
