@echo off

:#========================
:# 要修正
:#========================
:# .pyファイル名
set ProgramName=weighted_mobility.py
:# .pptxファイル名
set DocName=50-01-weighted_mobility.pptx

:#========================
:# 修正不要
:#========================
:# [Programs]ルート
set ProgramsRoot=d:\Programs
:# f:\python
set PythonRoot=f:\python
:# [data-COE]ルート
set ShareRoot=%PythonRoot%\data-COE
set EDITOR=D:\App\Editor\WZEditor64\wzeditor.exe

:# [data-COE]の.pptxフォルダー
set DocDir=%ShareRoot%\docs
:# [Programs]の.pptxフォルダー
set ProgramsManDir=%ProgramsRoot%\Manual

:#========================
:# 要修正
:#========================
:# [Programs]の.pyフォルダー
set ProgramsDir=%ProgramsRoot%\python\electrical\Seebeck\weighted_mobility
:# [data-COE]の.pyフォルダー
set ShareDir=%ShareRoot%\weighted_mobility
set PythonDir=%PythonRoot%\Electrical\Seebeck

:#========================
:# 以下、修正不要
:#========================
:# Programsの.pyファイルを更新コピー
set CopyCmd1=xcopy /D %ProgramsDir%\%ProgramName% %ShareDir%\%ProgramName%
:# f:\pythonの.pyファイルを更新コピー
set CopyCmd2=xcopy /D %PythonDir%\%ProgramName%   %ShareDir%\%ProgramName%
:# [data-COE]の.pptxファイルを更新コピー
set CopyCmd3=xcopy /D %ProgramsManDir%\%DocName%  %DocDir%\%DocName%


if "%1" == ""       goto CMD
if "%1" == "?"      goto USAGE
if "%1" == "list"   goto LIST
if "%1" == "update" goto UPDATE
if "%1" == "man"    goto MAN
if "%1" == "edit"   goto EDIT
if "%1" == "cd"     goto CD
if "%1" == "cmd"    goto CMD

goto END


:LIST
echo.
dir %ProgramsDir%\%ProgramName%
dir %ShareDir%\%ProgramName%
dir %PythonDir%\%ProgramName%

dir %DocDir%\%DocName%
dir %ProgramsManDir%\%DocName%
echo.

goto END

:UPDATE
echo.
echo Execute [%CopyCmd1%]
%CopyCmd1%

echo Execute [%CopyCmd2%]
%CopyCmd2%

echo Execute [%CopyCmd3%]
%CopyCmd3%
echo.

goto END

:MAN
echo Execute [start %DocDir%\%DocName%]
start %DocDir%\%DocName%
goto END

:EDIT
echo Execute [%EDITOR% %ShareDir%\%ProgramName%]
%EDITOR% %ShareDir%\%ProgramName%
goto END

:CMD
cmd.exe /K cd /D %ShareDir%\
goto END

:CD
cd /D %ShareDir%\
goto END

:USAGE
echo.
echo "Usage: update.bat [|?|list|update|man|edit|cd|cmd]"
echo.
goto END


:END
